/*
 * Part of the SlogSig project, an attempt to provide a type-safe
 * signals/slots mechanism for the C++ language.
 *
 * Copyright (C) 2003 Yves Bailly <kafka_AT_kafka-fr_DOT_net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
*/

#ifndef __SLOTSIG_H__
#define __SLOTSIG_H__

#include <set>
#ifdef __SLOTSIG_VERBOSE__
  #include <iostream>
#endif

#include "slotsig_common.h"

#ifndef __SLOTSIG_NB_PARAMS_MIN__
#define __SLOTSIG_NB_PARAMS_MIN__ 0
#else
  #if __SLOTSIG_NB_PARAMS_MIN__ < 0
    #undef __SLOTSIG_NB_PARAMS_MIN__
    #define __SLOTSIG_NB_PARAMS_MIN__ 0
    #warning The minimum number of parameters should be a number >= 0 !
  #endif
#endif

#ifndef __SLOTSIG_NB_PARAMS_MAX__
#define __SLOTSIG_NB_PARAMS_MAX__ 10
#else
  #if __SLOTSIG_NB_PARAMS_MAX__ > 10
    #undef __SLOTSIG_NB_PARAMS_MAX__
    #define __SLOTSIG_NB_PARAMS_MAX__ 10
    #warning The maximum number of paramterers should be a number <= 10 !
  #endif
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 0
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 1
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 2
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 3
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 4
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 5
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 6
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 7
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 8
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 9
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#undef __SLOTSIG_NB_PARAMS__
#define __SLOTSIG_NB_PARAMS__ 10
#if ( (__SLOTSIG_NB_PARAMS__ >= __SLOTSIG_NB_PARAMS_MIN__) && \
      (__SLOTSIG_NB_PARAMS__ <= __SLOTSIG_NB_PARAMS_MAX__) )
  #include "slotsig_gen.h"
#endif

#endif // __SLOTSIG_H__
