/*
 * Part of the SlogSig project, an attempt to provide a type-safe
 * signals/slots mechanism for the C++ language.
 *
 * Copyright (C) 2003 Yves Bailly <kafka_AT_kafka-fr_DOT_net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
*/

#ifndef __SLOTSIG_NB_PARAMS__
#error The macro __SLOTSIG_NB_PARAMS__ should be defined to the desired number of parameters
#endif

#undef __CL_SLOTSIG_BASE_NAME__
#undef __CL_SIG_NAME__
#undef __CL_SLOT_NAME__
#undef __CL_SLOT_INCLASS_NAME__
#undef __COMMA__

#undef __TEMPLATE_ARG_01__
#undef __TEMPLATE_ARG_02__
#undef __TEMPLATE_ARG_03__
#undef __TEMPLATE_ARG_04__
#undef __TEMPLATE_ARG_05__
#undef __TEMPLATE_ARG_06__
#undef __TEMPLATE_ARG_07__
#undef __TEMPLATE_ARG_08__
#undef __TEMPLATE_ARG_09__
#undef __TEMPLATE_ARG_10__
#undef __TEMPLATE_ARGS__

#undef __TEMPLATE_PARAM_01__
#undef __TEMPLATE_PARAM_02__
#undef __TEMPLATE_PARAM_03__
#undef __TEMPLATE_PARAM_04__
#undef __TEMPLATE_PARAM_05__
#undef __TEMPLATE_PARAM_06__
#undef __TEMPLATE_PARAM_07__
#undef __TEMPLATE_PARAM_08__
#undef __TEMPLATE_PARAM_09__
#undef __TEMPLATE_PARAM_10__
#undef __TEMPLATE_PARAMS__

#undef __METHOD_ARG_01__
#undef __METHOD_ARG_02__
#undef __METHOD_ARG_03__
#undef __METHOD_ARG_04__
#undef __METHOD_ARG_05__
#undef __METHOD_ARG_06__
#undef __METHOD_ARG_07__
#undef __METHOD_ARG_08__
#undef __METHOD_ARG_09__
#undef __METHOD_ARG_10__
#undef __METHOD_ARGS__

#undef __METHOD_PARAM_01__
#undef __METHOD_PARAM_02__
#undef __METHOD_PARAM_03__
#undef __METHOD_PARAM_04__
#undef __METHOD_PARAM_05__
#undef __METHOD_PARAM_06__
#undef __METHOD_PARAM_07__
#undef __METHOD_PARAM_08__
#undef __METHOD_PARAM_09__
#undef __METHOD_PARAM_10__
#undef __METHOD_PARAMS__

#if ( __SLOTSIG_NB_PARAMS__ > 0 )
  #define __COMMA__ ,
#else
  #define __COMMA__
#endif

#if __SLOTSIG_NB_PARAMS__ == 0

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase0
  #define __CL_SIG_NAME__             clSig0
  #define __CL_SLOT_NAME__            clSlot0
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass0

#elif __SLOTSIG_NB_PARAMS__ == 1

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase1
  #define __CL_SIG_NAME__             clSig1
  #define __CL_SLOT_NAME__            clSlot1
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass1

#elif __SLOTSIG_NB_PARAMS__ == 2

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase2
  #define __CL_SIG_NAME__             clSig2
  #define __CL_SLOT_NAME__            clSlot2
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass2
  #define __COMMA__ ,

#elif __SLOTSIG_NB_PARAMS__ == 3

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase3
  #define __CL_SIG_NAME__             clSig3
  #define __CL_SLOT_NAME__            clSlot3
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass3

#elif __SLOTSIG_NB_PARAMS__ == 4

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase4
  #define __CL_SIG_NAME__             clSig4
  #define __CL_SLOT_NAME__            clSlot4
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass4

#elif __SLOTSIG_NB_PARAMS__ == 5

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase5
  #define __CL_SIG_NAME__             clSig5
  #define __CL_SLOT_NAME__            clSlot5
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass5

#elif __SLOTSIG_NB_PARAMS__ == 6

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase6
  #define __CL_SIG_NAME__             clSig6
  #define __CL_SLOT_NAME__            clSlot6
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass6

#elif __SLOTSIG_NB_PARAMS__ == 7

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase7
  #define __CL_SIG_NAME__             clSig7
  #define __CL_SLOT_NAME__            clSlot7
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass7

#elif __SLOTSIG_NB_PARAMS__ == 8

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase8
  #define __CL_SIG_NAME__             clSig8
  #define __CL_SLOT_NAME__            clSlot8
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass8

#elif __SLOTSIG_NB_PARAMS__ == 9

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase9
  #define __CL_SIG_NAME__             clSig9
  #define __CL_SLOT_NAME__            clSlot9
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass9

#elif __SLOTSIG_NB_PARAMS__ == 10

  #define __CL_SLOTSIG_BASE_NAME__    clSlotSigBase10
  #define __CL_SIG_NAME__             clSig10
  #define __CL_SLOT_NAME__            clSlot10
  #define __CL_SLOT_INCLASS_NAME__    clSlotInClass10

#endif

#if __SLOTSIG_NB_PARAMS__ > 0

  #define __TEMPLATE_ARG_01__   typename _ARG_01_TYPE_
  #define __TEMPLATE_PARAM_01__ _ARG_01_TYPE_
  #define __METHOD_ARG_01__     _ARG_01_TYPE_ arg01
  #define __METHOD_PARAM_01__   arg01

#else // __SLOTSIG_NB_PARAMS__ > 0

  #define __TEMPLATE_ARG_01__
  #define __TEMPLATE_PARAM_01__
  #define __METHOD_ARG_01__
  #define __METHOD_PARAM_01__

#endif // __SLOTSIG_NB_PARAMS__ > 0

#if __SLOTSIG_NB_PARAMS__ > 1

  #define __TEMPLATE_ARG_02__   , typename _ARG_02_TYPE_
  #define __TEMPLATE_PARAM_02__ , _ARG_02_TYPE_
  #define __METHOD_ARG_02__     , _ARG_02_TYPE_ arg02
  #define __METHOD_PARAM_02__   , arg02

#else // __SLOTSIG_NB_PARAMS__ > 1

  #define __TEMPLATE_ARG_02__
  #define __TEMPLATE_PARAM_02__
  #define __METHOD_ARG_02__
  #define __METHOD_PARAM_02__

#endif // __SLOTSIG_NB_PARAMS__ > 1

#if __SLOTSIG_NB_PARAMS__ > 2

  #define __TEMPLATE_ARG_03__   , typename _ARG_03_TYPE_
  #define __TEMPLATE_PARAM_03__ , _ARG_03_TYPE_
  #define __METHOD_ARG_03__     , _ARG_03_TYPE_ arg03
  #define __METHOD_PARAM_03__   , arg03

#else // __SLOTSIG_NB_PARAMS__ > 2

  #define __TEMPLATE_ARG_03__
  #define __TEMPLATE_PARAM_03__
  #define __METHOD_ARG_03__
  #define __METHOD_PARAM_03__

#endif // __SLOTSIG_NB_PARAMS__ > 2

#if __SLOTSIG_NB_PARAMS__ > 3

  #define __TEMPLATE_ARG_04__   , typename _ARG_04_TYPE_
  #define __TEMPLATE_PARAM_04__ , _ARG_04_TYPE_
  #define __METHOD_ARG_04__     , _ARG_04_TYPE_ arg04
  #define __METHOD_PARAM_04__   , arg04

#else // __SLOTSIG_NB_PARAMS__ > 3

  #define __TEMPLATE_ARG_04__
  #define __TEMPLATE_PARAM_04__
  #define __METHOD_ARG_04__
  #define __METHOD_PARAM_04__

#endif // __SLOTSIG_NB_PARAMS__ > 3

#if __SLOTSIG_NB_PARAMS__ > 4

  #define __TEMPLATE_ARG_05__   , typename _ARG_05_TYPE_
  #define __TEMPLATE_PARAM_05__ , _ARG_05_TYPE_
  #define __METHOD_ARG_05__     , _ARG_05_TYPE_ arg05
  #define __METHOD_PARAM_05__   , arg05

#else // __SLOTSIG_NB_PARAMS__ > 4

  #define __TEMPLATE_ARG_05__
  #define __TEMPLATE_PARAM_05__
  #define __METHOD_ARG_05__
  #define __METHOD_PARAM_05__

#endif // __SLOTSIG_NB_PARAMS__ > 4

#if __SLOTSIG_NB_PARAMS__ > 5

  #define __TEMPLATE_ARG_06__   , typename _ARG_06_TYPE_
  #define __TEMPLATE_PARAM_06__ , _ARG_06_TYPE_
  #define __METHOD_ARG_06__     , _ARG_06_TYPE_ arg06
  #define __METHOD_PARAM_06__   , arg06

#else // __SLOTSIG_NB_PARAMS__ > 5

  #define __TEMPLATE_ARG_06__
  #define __TEMPLATE_PARAM_06__
  #define __METHOD_ARG_06__
  #define __METHOD_PARAM_06__

#endif // __SLOTSIG_NB_PARAMS__ > 5

#if __SLOTSIG_NB_PARAMS__ > 6

  #define __TEMPLATE_ARG_07__   , typename _ARG_07_TYPE_
  #define __TEMPLATE_PARAM_07__ , _ARG_07_TYPE_
  #define __METHOD_ARG_07__     , _ARG_07_TYPE_ arg07
  #define __METHOD_PARAM_07__   , arg07

#else // __SLOTSIG_NB_PARAMS__ > 6

  #define __TEMPLATE_ARG_07__
  #define __TEMPLATE_PARAM_07__
  #define __METHOD_ARG_07__
  #define __METHOD_PARAM_07__

#endif // __SLOTSIG_NB_PARAMS__ > 6

#if __SLOTSIG_NB_PARAMS__ > 7

  #define __TEMPLATE_ARG_08__   , typename _ARG_08_TYPE_
  #define __TEMPLATE_PARAM_08__ , _ARG_08_TYPE_
  #define __METHOD_ARG_08__     , _ARG_08_TYPE_ arg08
  #define __METHOD_PARAM_08__   , arg08

#else // __SLOTSIG_NB_PARAMS__ > 7

  #define __TEMPLATE_ARG_08__
  #define __TEMPLATE_PARAM_08__
  #define __METHOD_ARG_08__
  #define __METHOD_PARAM_08__

#endif // __SLOTSIG_NB_PARAMS__ > 7

#if __SLOTSIG_NB_PARAMS__ > 8

  #define __TEMPLATE_ARG_09__   , typename _ARG_09_TYPE_
  #define __TEMPLATE_PARAM_09__ , _ARG_09_TYPE_
  #define __METHOD_ARG_09__     , _ARG_09_TYPE_ arg09
  #define __METHOD_PARAM_09__   , arg09

#else // __SLOTSIG_NB_PARAMS__ > 8

  #define __TEMPLATE_ARG_09__
  #define __TEMPLATE_PARAM_09__
  #define __METHOD_ARG_09__
  #define __METHOD_PARAM_09__

#endif // __SLOTSIG_NB_PARAMS__ > 8

#if __SLOTSIG_NB_PARAMS__ > 9

  #define __TEMPLATE_ARG_10__   , typename _ARG_10_TYPE_
  #define __TEMPLATE_PARAM_10__ , _ARG_10_TYPE_
  #define __METHOD_ARG_10__     , _ARG_10_TYPE_ arg10
  #define __METHOD_PARAM_10__   , arg10

#else // __SLOTSIG_NB_PARAMS__ > 9

  #define __TEMPLATE_ARG_10__
  #define __TEMPLATE_PARAM_10__
  #define __METHOD_ARG_10__
  #define __METHOD_PARAM_10__

#endif // __SLOTSIG_NB_PARAMS__ > 9

#if __SLOTSIG_NB_PARAMS__ > 10
#error Sorry, for now SlotSig dont handle more than 10 parameters !
#endif

#define __TEMPLATE_ARGS__ __TEMPLATE_ARG_01__ \
                          __TEMPLATE_ARG_02__ \
                          __TEMPLATE_ARG_03__ \
                          __TEMPLATE_ARG_04__ \
                          __TEMPLATE_ARG_05__ \
                          __TEMPLATE_ARG_06__ \
                          __TEMPLATE_ARG_07__ \
                          __TEMPLATE_ARG_08__ \
                          __TEMPLATE_ARG_09__ \
                          __TEMPLATE_ARG_10__

#define __TEMPLATE_PARAMS__ __TEMPLATE_PARAM_01__ \
                            __TEMPLATE_PARAM_02__ \
                            __TEMPLATE_PARAM_03__ \
                            __TEMPLATE_PARAM_04__ \
                            __TEMPLATE_PARAM_05__ \
                            __TEMPLATE_PARAM_06__ \
                            __TEMPLATE_PARAM_07__ \
                            __TEMPLATE_PARAM_08__ \
                            __TEMPLATE_PARAM_09__ \
                            __TEMPLATE_PARAM_10__

#define __METHOD_ARGS__ __METHOD_ARG_01__ \
                        __METHOD_ARG_02__ \
                        __METHOD_ARG_03__ \
                        __METHOD_ARG_04__ \
                        __METHOD_ARG_05__ \
                        __METHOD_ARG_06__ \
                        __METHOD_ARG_07__ \
                        __METHOD_ARG_08__ \
                        __METHOD_ARG_09__ \
                        __METHOD_ARG_10__

#define __METHOD_PARAMS__ __METHOD_PARAM_01__ \
                          __METHOD_PARAM_02__ \
                          __METHOD_PARAM_03__ \
                          __METHOD_PARAM_04__ \
                          __METHOD_PARAM_05__ \
                          __METHOD_PARAM_06__ \
                          __METHOD_PARAM_07__ \
                          __METHOD_PARAM_08__ \
                          __METHOD_PARAM_09__ \
                          __METHOD_PARAM_10__

