/*
 * Part of the SlogSig project, an attempt to provide a type-safe
 * signals/slots mechanism for the C++ language.
 *
 * Copyright (C) 2003 Yves Bailly <kafka_AT_kafka-fr_DOT_net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
*/

template <typename _RETURN_TYPE_
          __COMMA__
          __TEMPLATE_ARGS__>
class __CL_SLOT_NAME__ : public __CL_SLOTSIG_BASE_NAME__<_RETURN_TYPE_
                                                         __COMMA__
                                                         __TEMPLATE_PARAMS__>
{
  friend class __CL_SIG_NAME__<_RETURN_TYPE_
                               __COMMA__
                               __TEMPLATE_PARAMS__> ;
  public:
    typedef __CL_SIG_NAME__<_RETURN_TYPE_
                            __COMMA__
                            __TEMPLATE_PARAMS__> clSig ;
    typedef std::set<clSig*> clSigSet ;
    typedef __CL_SLOTSIG_BASE_NAME__<_RETURN_TYPE_
                                     __COMMA__
                                     __TEMPLATE_PARAMS__> clSlotSigBase ;

    __CL_SLOT_NAME__() :
      clSlotSigBase()
    { }

    virtual ~__CL_SLOT_NAME__()
    { }

    virtual void connect (clSig* slot_sig)
    { clSlotSigBase::connect(slot_sig) ; }

    virtual void disconnect (clSig* slot_sig)
    { clSlotSigBase::disconnect(slot_sig) ; }

    //! Returns the set of signals connected to this slot.
    const clSigSet& sigSet() const
    { return slotSigSet() ; }

    //! The method called when one of the signal is emitted.

    virtual _RETURN_TYPE_ operator() (__METHOD_ARGS__)
    { return _RETURN_TYPE_() ; }

} ;

